

.include 	"tn13Adef.inc"		;  AtTiny13


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21 			;  
.def	Temp6=R22			;   			
.def	Temp7=R23			;   		
.def	Temp8=R24
.def	Temp9=R25


.dseg					; 

OZU: .byte 2				;  2   


;******************************************************************************


.cseg			

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

rjmp RESET				



.org ADCCaddr				; ADC Conversion Complete

rjmp ADC_2


.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b00001000		;   "" (0-, 1-)
	out DDRB,Temp			; 000000 - "" 
					; 0000000 - ""   
					; 0000000 - ""  (ADC2)
				



	ldi Temp,0b00000000		;  !
	out PortB,Temp			; 




	RCALL	LCD_INIT		;  




;_______________________________________________________________________________________________________________

	ldi Temp,(2<<MUX0)		
	out ADMUX,Temp	
					; REFS0=0 /   5V 
					; ADLAR=0 /   ( 8     2    )
					; MUX1=1 
					; MUX0=0 /   ADC2 ( PB4 )


	

	ldi Temp, (1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIE)|(7<<ADPS0)
	out ADCSRA,Temp
					; ADEN=1 /  
					; ADSC=1 /   
					; ADATE=1 /  
					; ADIF=0 /      
					; ADIE=1 /    
					; ADPS2=1
					; ADPS1=1
					; ADPS0=1 /   1/128 ( 9,6  / 128 = 75  )



;	ldi Temp, (0<<ADTS0)
;	out ADCSRB,Temp
					; ACME=0 /      
					; ADTS2=0
					; ADTS1=0
					; ADTS0=0 /    (       )

;________________________________________________________________________________________________________________

	




	ldi Temp5,0			;   


	ldi Temp6,1			;    


	sei				;   
	

;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************


Main_cicle:



	cpi Temp5,1			;    ?	
	brne Main_cicle			;   ,  


	ldi Temp5,0			;   


	sbrc temp6, 0			;   ,   ,     
	rjmp opred_sevshiy_akkum	;    ,     

	rjmp obhod

vozvrat:

;________________________________________________________________________________________
	LDI R18, 0			; (Y)
	LDI R17, 0			; (X) 
	RCALL LCD_POS			;   

	MOV Temp,Temp7
	rcall lcd_char			;     

	rcall zaderjka			; 
;_________________________________________________________________________________________

obhod:

	LDI R18, 0			; (Y)
	LDI R17, 0			; (X) 
	RCALL LCD_POS			;   


	rcall out_disp			;     16-  


	rjmp Main_cicle			;  -         


;*****************************************************************************************
;     (  8V =  )
;*****************************************************************************************

opred_sevshiy_akkum:


	ldi Temp6,0			;    
					

	ldi Temp,0b00000001		; 8  = 0111100111
	ldi Temp1,0b11100111


	rcall compare			; ...

	breq bolshe_8_Volt		;     X=Z 
	brcs bolshe_8_Volt		;     X<Z
	rjmp menshe_8_Volt		;     X>Z 



;*****************************************************************************************
;     
;*****************************************************************************************

bolshe_8_Volt:				;    

;_________________________________________________________________________________________
	LDI R18, 0			; (Y)
	LDI R17, 0			; (X) 
	RCALL LCD_POS			;   


	LDI Temp,1
	rcall lcd_char			;    "1"

	rcall zaderjka			; 
;_________________________________________________________________________________________

	rjmp opred_kolich_banok		; 





menshe_8_Volt:				;     

;_________________________________________________________________________________________
	LDI R18, 0			; (Y)
	LDI R17, 0			; (X) 
	RCALL LCD_POS			;   


	LDI Temp,0
	rcall lcd_char			;    "0"

	rcall zaderjka			; 
;_________________________________________________________________________________________

	rjmp opred_kolich_banok		; 



;*****************************************************************************************
;    
;*****************************************************************************************

opred_kolich_banok:

	ldi Temp, 0b00000011		; 16,8  = 1111111111 ( 5    )
	ldi Temp1,0b11111111


	rcall compare			; ...

	breq x_4bank			;     X=Z 
	brcs x_4bank			;     X<Z (   )
	rjmp x_3bank_op			;     X>Z 


x_4bank:


	ldi Temp7,4			;    = 4

	rjmp vozvrat


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


x_3bank_op:


	ldi Temp, 0b00000010		; 12,6  = 1011111111 ( 3,75    )
	ldi Temp1,0b11111111


	rcall compare			; ...

	breq x_3bank			;     X=Z 
	brcs x_4bank			;     X<Z 
	rjmp x_2bank_op			;     X>Z 


x_3bank:

	ldi Temp7,3			;    = 3

	rjmp vozvrat


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

x_2bank_op:



	ldi Temp, 0b00000001		; 8,4  = 1011111111 ( 2,49    )
	ldi Temp1,0b11111111


	rcall compare			; ...

	breq x_2bank			;     X=Z 
	brcs x_3bank			;     X<Z 
	rjmp x_2bank			;     X>Z 


x_2bank:

	ldi Temp7,2			;    = 2

	rjmp vozvrat

;*****************************************************************************************
;   
;*****************************************************************************************

zaderjka:


	ldi Temp,255			;  

	Ldi Temp4,4

delay_256:
	
	dec Temp
	brne delay_256

	dec Temp4
	brne delay_256


	ret

;*****************************************************************************************
;   
;*****************************************************************************************


compare:

	cp Temp,ZH			;    
	breq xh_eq_Zh			;    ,    Xl  Zl
					;   -   X<Z
					;   -   X>Z
	ret



xh_eq_Zh:

	cp Temp1,ZL			;    
					;  Z=1  X=Z
					;   -   X<Z
					;   -   X>Z

	ret      


;*********************************************************************************************************************************
;  
;*********************************************************************************************************************************

ADC_2:

	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4


	ldi Temp5,1			;   



	in zl,ADCL			;     "z"  "ADCH"  "ADCL"
	in zh,ADCH 



	ANDI zh,0b00000011		;  (     ?    ? )???????????????????????????????????????????????????????????????

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4


	reti



;**************************************************************************************************************
;      
;**************************************************************************************************************

out_disp:

	mov Temp, zL			;    ( ADCL )
	push Temp			;    

	mov Temp, zH			;    ( ADCH )
	rcall printhex			;    

	pop Temp			;  



printhex:

	push Temp			;   
	swap Temp			;        (SWAP -   )

	rcall printhex1			;    
	pop  Temp			;    


printhex1:				;  

	andi Temp, 0x0f			;  00001111 (  ) 
	rcall lcd_char			;    
	ret 


;*******************************************************************************




.include "lcd5110mini.asm"		;   





	

